## net.sf.saxon.value
Class UntypedAtomicValue

    java.lang.Object
      net.sf.saxon.value.Value
          net.sf.saxon.value.AtomicValue
              net.sf.saxon.value.StringValue
                  net.sf.saxon.value.UntypedAtomicValue

All Implemented Interfaces:
  Expression, Item, java.io.Serializable, ValueRepresentation

public class UntypedAtomicValue
extends StringValue

An Untyped Atomic value. This inherits from StringValue for implementation convenience, even though an untypedAtomic value is not a String in the data model type hierarchy.

See Also:
  Serialized Form

Nested Class Summary

Nested classes inherited from class net.sf.saxon.value.StringValue
`StringValue.CharacterIterator`

Field Summary
`static UntypedAtomicValue` `ZERO_LENGTH_UNTYPED`

Fields inherited from class net.sf.saxon.value.StringValue
`EMPTY_STRING, length, SINGLE_SPACE, value`

Fields inherited from class net.sf.saxon.value.Value
`EMPTY_CLASS_ARRAY`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`UntypedAtomicValue(java.lang.CharSequence value)` Constructor

Method Summary
`int` `compareTo(java.lang.Object other, java.util.Comparator collator, XPathContext context)` Compare an untypedAtomic value with another value, using a given collator to perform any string comparisons.
`AtomicValue` `convertPrimitive(BuiltInAtomicType requiredType, boolean validate, XPathContext context)` Convert to target data type
`ItemType` `getItemType(TypeHierarchy th)` Return the type of the expression
`boolean` `schemaEquals(Value obj)` Compare two values for equality.

Methods inherited from class net.sf.saxon.value.StringValue
`contract, convertStringToAtomicType, convertStringToBuiltInType, convertToJava, effectiveBooleanValue, equals, expand, getStringLength, getStringLength, getStringValue, getStringValueCS, hashCode, iterateCharacters, makeStringValue, toString`

Methods inherited from class net.sf.saxon.value.AtomicValue
`checkPermittedContents, convert, convert, display, evaluateAsString, evaluateItem, getCardinality, getComponent, getImplementationMethod, getLength, getPrimitiveValue, getTypedValue, hasBuiltInType, iterate, process`

Methods inherited from class net.sf.saxon.value.Value
`asItem, asIterator, asValue, collapseWhitespace, convert, convertJavaObjectToXPath, getDependencies, getIterator, getParentExpression, getSpecialProperties, itemAt, iterateSubExpressions, makeQNameValue, normalizeWhitespace, optimize, promote, reduce, simplify, stringToNumber, trimWhitespace, typeCheck`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### ZERO_LENGTH_UNTYPED

    public static final UntypedAtomicValue ZERO_LENGTH_UNTYPED

Constructor Detail

### UntypedAtomicValue

    public UntypedAtomicValue(java.lang.CharSequence value)

  Constructor

Parameters:
  `value` - the String value. Null is taken as equivalent to "".

Method Detail

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Return the type of the expression

  Specified by:
    `getItemType` in interface `Expression`
  Overrides:
    `getItemType` in class `StringValue`
  Parameters:
    `th` -
  Returns:
    Type.UNTYPED_ATOMIC (always)

### convertPrimitive

    public AtomicValue convertPrimitive(BuiltInAtomicType requiredType,
                                        boolean validate,
                                        XPathContext context)

  Convert to target data type

  Overrides:
    `convertPrimitive` in class `StringValue`
  Parameters:
    `requiredType` - type code of the required atomic type
    `validate` - true if validation is required. If set to false, the caller guarantees that the value is valid for the target data type, and that further validation is therefore not required. Note that a validation failure may be reported even if validation was not requested.
    `context` -
  Returns:
    the result of the conversion, if successful. If unsuccessful, the value returned will be a ValidationErrorValue. The caller must check for this condition. No exception is thrown, instead the exception will be encapsulated within the ErrorValue.

### compareTo

    public int compareTo(java.lang.Object other,
                         java.util.Comparator collator,
                         XPathContext context)

  Compare an untypedAtomic value with another value, using a given collator to perform any string comparisons. This works by converting the untypedAtomic value to the type of the other operand, which is the correct behavior for operators like "=" and "!=", but not for "eq" and "ne": in the latter case, the untypedAtomic value is converted to a string and this method is therefore not used.

  Returns:
    -1 if the this value is less than the other, 0 if they are equal, +1 if this value is greater.

### schemaEquals

    public boolean schemaEquals(Value obj)

  Compare two values for equality. This supports identity constraints in XML Schema, which allow list-valued elements and attributes to participate in key and uniqueness constraints. This method returns false if any error occurs during the comparison, or if any of the items in either sequence is a node rather than an atomic value. The default implementation of schemaEquals() is the same as equals(), but subclasses can override this.

  Overrides:
    `schemaEquals` in class `StringValue`